//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TBasicGalaxyModule.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TBasicGalaxyModule *BasicGalaxyModule;
//---------------------------------------------------------------------------
__fastcall TBasicGalaxyModule::TBasicGalaxyModule(TComponent* Owner)
  : TDataModule(Owner)
{
}
//---------------------------------------------------------------------------

void TBasicGalaxyModule::ActivateAllTables()
{
  for (int i=0; i<ComponentCount; i++) {
    TTable* C = dynamic_cast<TTable*>(Components[i]);
    if (C) {
      C->Active = true;
    }
  }
}
//---------------------------------------------------------------------------

void TBasicGalaxyModule::DeactivateAllTables()
{
  for (int i=0; i<ComponentCount; i++) {
    TTable* C = dynamic_cast<TTable*>(Components[i]);
    if (C) {
      C->Active = false;
    }
  }
}
//---------------------------------------------------------------------------

void TBasicGalaxyModule::SetDatabase(String aliasName)
{
  for (int i=0; i<ComponentCount; i++) {
    TDBDataSet* C = dynamic_cast<TDBDataSet*>(Components[i]);
    if (C) {
      bool WasActive = C->Active;
      C->Active = false;
      C->DatabaseName = aliasName;
      C->Active = WasActive;
    }
  }
  TStringList* Params = new TStringList();
  Session->GetAliasParams(aliasName, Params);
  DataDirectory = Params->Strings[0];
  delete Params;
  DataDirectory.Delete(1, 5);
  DataDirectory = IncludeTrailingBackslash(DataDirectory);

}
//---------------------------------------------------------------------------

void TBasicGalaxyModule::FilterDataSets(bool filtered)
{
  for (int i=0; i<ComponentCount; i++) {
    TBDEDataSet* C = dynamic_cast<TBDEDataSet*>(Components[i]);
    if (C) {
      C->Filtered = filtered;
    }
  }
}
//---------------------------------------------------------------------------

String TBasicGalaxyModule::GetDataDirectory()
{
  return DataDirectory;
}
//---------------------------------------------------------------------------


