//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <Filectrl.hpp>
#include "TDATGridView.h"
#include "TGalaxyModule.h"
#include "TEFSMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDATGridView *DATGridView;
//---------------------------------------------------------------------------
__fastcall TDATGridView::TDATGridView(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TDATGridView::FormClose(TObject *Sender,
      TCloseAction &Action)
{
/* DONE -oMitchell :
Save DAT tables to DAT files as appropriate
(e.g., use the DATPath of the current Project) */

  String s = String("Do you wish to save the DAT database to DAT text files before closing?");
  int result = MessageDlg(s, mtInformation, TMsgDlgButtons() << mbYes << mbNo << mbCancel, 0);
  if (result == mrYes) {
    if (DirectoryExists(EFSMain->LastDATPath)) {
      GalaxyModule->SaveDATFiles(EFSMain->LastDATPath);
    }
    else {
      String s = String("The expected DAT directory: ") + EFSMain->LastDATPath
                 + String("\nwas not found; DAT text files not saved...");
      MessageDlg(s, mtWarning, TMsgDlgButtons() << mbOK, 0);
      Action = caNone;
      return;
    }
  }
  else if (result == mrCancel) {
    // If the user chose to Cancel, do not allow the form to close and return:
    Action = caNone;
    return;
  }

  // Whether the DAT database was saved or not, allow the window to close:
  Action = caFree;
  DATGridView = NULL;

}
//---------------------------------------------------------------------------
void __fastcall TDATGridView::FormCreate(TObject *Sender)
{
  for (int i=0; i<GalaxyModule->ComponentCount; i++) {
    TTable* C = dynamic_cast<TTable*>(GalaxyModule->Components[i]);
    if (C) {
      if (C->Tag == 2) {
        cbDATTables->Items->AddObject(C->Name, C);
      }
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TDATGridView::FormShow(TObject *Sender)
{
  int index = cbDATTables->Items->IndexOf("UnitDAT");
  cbDATTables->ItemIndex = index;
  cbDATTablesChange(this);
}
//---------------------------------------------------------------------------

void __fastcall TDATGridView::cbDATTablesChange(TObject *Sender)
{
  GalaxyModule->dsDAT->DataSet =
    dynamic_cast<TDataSet*>(cbDATTables->Items->Objects[cbDATTables->ItemIndex]);
}
//---------------------------------------------------------------------------

