//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "TEFSCUnit.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

TEFSCUnit::TEFSCUnit() {
  pNext = pPrev = pNIG = pPIG = NULL;
  for (int i=0; i<MAX_CARGO; i++) {
    Cargo[i] = NULL;
  }
  GroupEndMark = 0;

  // Initialize fields not loaded from the *.GAL file:
  MoveType = 0;
  MoveCost = 0;
  tFlags = 0;
}
//---------------------------------------------------------------------------
TEFSCUnit::~TEFSCUnit() {

}
//---------------------------------------------------------------------------
int TEFSCUnit::Save(ofstream* outfile) {

  outfile->write((char*)&FPIdx, sizeof(FPIdx));
  outfile->write((char*)&Fx, sizeof(Fx));
  outfile->write((char*)&Fy, sizeof(Fy));

  outfile->write((char*)&Owner, sizeof(Owner));
  outfile->write((char*)&Type, sizeof(Type));
  outfile->write((char*)&tLvl, sizeof(Owner));

  outfile->write((char*)&FLoyalty, sizeof(FLoyalty));

  outfile->write((char*)&Orders, sizeof(Orders));
  outfile->write((char*)&Experience, sizeof(Experience));
  outfile->write((char*)&MovePoints, sizeof(MovePoints));
  outfile->write((char*)&ResRelic, sizeof(ResRelic));
  outfile->write((char*)&Amount, sizeof(Amount));
  outfile->write((char*)&Health, sizeof(Health));
  outfile->write((char*)&Sect, sizeof(Sect));
  outfile->write((char*)&PrevOwner, sizeof(PrevOwner));
  outfile->write((char*)&UnitNo, sizeof(UnitNo));
  outfile->write((char*)&Flags, sizeof(Flags));
  outfile->write((char*)&UsedUnitType, sizeof(UsedUnitType));
  outfile->write((char*)&UsedUnittLvl, sizeof(UsedUnittLvl));
  outfile->write((char*)&Camo, sizeof(Camo));
  outfile->write((char*)&DestX, sizeof(DestX));
  outfile->write((char*)&DestY, sizeof(DestY));

  outfile->write((char*)&AIOrders, sizeof(AIOrders));
  outfile->write((char*)&AIData, sizeof(AIData));
  outfile->write((char*)&AIData2, sizeof(AIData2));
  outfile->write((char*)&WaitLevel, sizeof(WaitLevel));

  if (GroupEndMark == -3) {
    outfile->write((char*)&GroupEndMark, sizeof(GroupEndMark));
  }

  return true;
}
//---------------------------------------------------------------------------
int TEFSCUnit::Load(ifstream* infile, bool saveGame, int saveVersion, int origVersion) {

  infile->read((char*)&Owner, sizeof(Owner));
  infile->read((char*)&Type, sizeof(Type));
  infile->read((char*)&tLvl, sizeof(Owner));

  char loyalty;
  infile->read((char*)&loyalty, sizeof(loyalty));
  SetLoyalty(loyalty);

  infile->read((char*)&Orders, sizeof(Orders));
  infile->read((char*)&Experience, sizeof(Experience));
  infile->read((char*)&MovePoints, sizeof(MovePoints));
  infile->read((char*)&ResRelic, sizeof(ResRelic));
  infile->read((char*)&Amount, sizeof(Amount));
  infile->read((char*)&Health, sizeof(Health));
  infile->read((char*)&Sect, sizeof(Sect));
  infile->read((char*)&PrevOwner, sizeof(PrevOwner));
  infile->read((char*)&UnitNo, sizeof(UnitNo));
  infile->read((char*)&Flags, sizeof(Flags));
  infile->read((char*)&UsedUnitType, sizeof(UsedUnitType));
  infile->read((char*)&UsedUnittLvl, sizeof(UsedUnittLvl));
  infile->read((char*)&Camo, sizeof(Camo));
  infile->read((char*)&DestX, sizeof(DestX));
  infile->read((char*)&DestY, sizeof(DestY));

  infile->read((char*)&AIOrders, sizeof(AIOrders));
  infile->read((char*)&AIData, sizeof(AIData));

  if ((origVersion >= 961025) || (saveVersion >= 961027)) {
    infile->read((char*)&AIData2, sizeof(AIData2));
    infile->read((char*)&WaitLevel, sizeof(WaitLevel));
  }

  return true;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
