//---------------------------------------------------------------------------

#ifndef TGalaxyModuleH
#define TGalaxyModuleH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "StrBuildProcessor.hpp"
#include "TBasicGalaxyModule.h"
#include "TechDatProcessor.hpp"
#include "UnitProcessor.hpp"
#include <Db.hpp>
#include <DBTables.hpp>
#include "DamageProcessor.hpp"
#include "ProdDatProcessor.hpp"
#include "STCRCProcessor.hpp"
#include "TargetProcessor.hpp"
#include "HarvestDataProcessor.hpp"
#include "USTCProcessor.hpp"
#include "ResDatProcessor.hpp"
//---------------------------------------------------------------------------
class TGalaxyModule : public TBasicGalaxyModule
{
__published:	// IDE-managed Components
  TDataSource *dsPlanets;
  TDataSource *dsJumpRoutes;
  TDataSource *dsUnits;
  TDataSource *dsStructures;
  TDataSource *dsFactions;
  TDataSource *dsSects;
  TDataSource *dsEditUnits;
  TTable *EditUnitsTable;
  TIntegerField *EditUnitsTableUnitID;
  TSmallintField *EditUnitsTablePIdx;
  TSmallintField *EditUnitsTableX;
  TSmallintField *EditUnitsTableY;
  TSmallintField *EditUnitsTableLoyalty;
  TSmallintField *EditUnitsTableOwner;
  TSmallintField *EditUnitsTablePrevOwner;
  TSmallintField *EditUnitsTableType;
  TSmallintField *EditUnitsTableTLvl;
  TSmallintField *EditUnitsTableMoveType;
  TSmallintField *EditUnitsTableOrders;
  TSmallintField *EditUnitsTableExperience;
  TSmallintField *EditUnitsTableMovePoints;
  TSmallintField *EditUnitsTableResRelic;
  TSmallintField *EditUnitsTableAmount;
  TSmallintField *EditUnitsTableHealth;
  TSmallintField *EditUnitsTableSect;
  TIntegerField *EditUnitsTableUnitNo;
  TIntegerField *EditUnitsTableFlags;
  TSmallintField *EditUnitsTableUsedUnitType;
  TSmallintField *EditUnitsTableUsedUnittLvl;
  TSmallintField *EditUnitsTableCamo;
  TSmallintField *EditUnitsTableDestX;
  TSmallintField *EditUnitsTableDestY;
  TIntegerField *EditUnitsTableMoveCost;
  TSmallintField *EditUnitsTableTFlags;
  TSmallintField *EditUnitsTableAIOrders;
  TSmallintField *EditUnitsTableAIData;
  TSmallintField *EditUnitsTableAIData2;
  TSmallintField *EditUnitsTableWaitLevel;
  TSmallintField *EditUnitsTableGroupEndMark;
  TDataSource *dsPlanetType;
  TUnitProcessor *UnitProcessor;
  TStrBuildProcessor *StrBuildProcessor;
  TTechDatProcessor *TechDatProcessor;
  TDataSource *dsDAT;
  TDamageProcessor *DamageProcessor;
  TTargetProcessor *TargetProcessor;
  TSTCRCProcessor *StockProcessor;
  TSTCRCProcessor *TerColorProcessor;
  TSTCRCProcessor *RoadCostProcessor;
  TProdDatProcessor *ProdProcessor;
  THarvestDataProcessor *HarvestProcessor;
  TUSTCProcessor *USTCProcessor;
  TStringField *UnitTableSectLU;
  TStringField *StructureTableSectLU;
  TStringField *StructureTableTypeLU;
  TStringField *StructureTableTechTypeLU;
  TStringField *StructureTablePrevTypeLU;
  TResDatProcessor *ResProcessor;
  TIntegerField *StructureDATID;
  TStringField *StructureDATName;
  TSmallintField *StructureDATWater;
  TSmallintField *StructureDATLand;
  TSmallintField *StructureDATRoad;
  TSmallintField *StructureDATBarren;
  TSmallintField *StructureDATNeutral;
  TSmallintField *StructureDATBuild;
  TSmallintField *StructureDATArea;
  TSmallintField *StructureDATCrdTr;
  TIntegerField *StructureDATCredits;
  TSmallintField *StructureDATT2B;
  TSmallintField *StructureDATTech;
  TIntegerField *StructureDATValue;
  TStringField *StructureDATTechLU;
  TStringField *PlanetTableSectLU;
  TDataSource *dsUnitDAT;
  TStringField *UnitTableMPText;
  TSmallintField *EditUnitsTableTTL;
  TSmallintField *EditUnitsTableUUTTL;
  TStringField *UnitTableCamoText;
  TStringField *UnitTableLocText;
  TStringField *UnitTableNameText;
  TStringField *UnitTableHealthText;
  TStringField *UnitTableMoveText;
  void __fastcall UnitTableCalcFields(TDataSet *DataSet);
private:	// User declarations
public:		// User declarations
  __fastcall TGalaxyModule(TComponent* Owner);
  bool LoadDATFiles(String datPath);
  void CreateProject(String projectAlias);
  bool SaveDATFiles(String datPath);
};
//---------------------------------------------------------------------------
extern PACKAGE TGalaxyModule *GalaxyModule;
//---------------------------------------------------------------------------
#endif
