//---------------------------------------------------------------------------

#ifndef TNewGalaxyModuleH
#define TNewGalaxyModuleH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "StrBuildProcessor.hpp"
#include "TBasicGalaxyModule.h"
#include "TechDatProcessor.hpp"
#include "UnitProcessor.hpp"
#include <Db.hpp>
#include <DBTables.hpp>
//---------------------------------------------------------------------------
class TNewGalaxyModule : public TBasicGalaxyModule
{
__published:	// IDE-managed Components
  TDataSource *dsPlanets;
  TDataSource *dsJumpRoutes;
  TDataSource *dsUnits;
  TDataSource *dsStructures;
  TDataSource *dsFactions;
  TDataSource *dsSects;
  TDataSource *dsEditUnits;
  TTable *EditUnitsTable;
  TIntegerField *EditUnitsTableUnitID;
  TSmallintField *EditUnitsTablePIdx;
  TSmallintField *EditUnitsTableX;
  TSmallintField *EditUnitsTableY;
  TSmallintField *EditUnitsTableLoyalty;
  TSmallintField *EditUnitsTableOwner;
  TSmallintField *EditUnitsTablePrevOwner;
  TSmallintField *EditUnitsTableType;
  TSmallintField *EditUnitsTableTLvl;
  TSmallintField *EditUnitsTableMoveType;
  TSmallintField *EditUnitsTableOrders;
  TSmallintField *EditUnitsTableExperience;
  TSmallintField *EditUnitsTableMovePoints;
  TSmallintField *EditUnitsTableResRelic;
  TSmallintField *EditUnitsTableAmount;
  TSmallintField *EditUnitsTableHealth;
  TSmallintField *EditUnitsTableSect;
  TIntegerField *EditUnitsTableUnitNo;
  TIntegerField *EditUnitsTableFlags;
  TSmallintField *EditUnitsTableUsedUnitType;
  TSmallintField *EditUnitsTableUsedUnittLvl;
  TSmallintField *EditUnitsTableCamo;
  TSmallintField *EditUnitsTableDestX;
  TSmallintField *EditUnitsTableDestY;
  TIntegerField *EditUnitsTableMoveCost;
  TSmallintField *EditUnitsTableTFlags;
  TSmallintField *EditUnitsTableAIOrders;
  TSmallintField *EditUnitsTableAIData;
  TSmallintField *EditUnitsTableAIData2;
  TSmallintField *EditUnitsTableWaitLevel;
  TSmallintField *EditUnitsTableGroupEndMark;
  TDataSource *dsPlanetType;
  TTable *PlanetLookUp;
  TIntegerField *PlanetLookUpPIdx;
  TStringField *PlanetLookUpName;
  TUnitProcessor *UnitProcessor;
  TStrBuildProcessor *StrBuildProcessor;
  TTechDatProcessor *TechDatProcessor;
  TDataSource *dsUnitDAT;
  TDataSource *dsStructureDAT;
  TDataSource *dsTechDAT;
  void __fastcall UnitTableCalcFields(TDataSet *DataSet);
private:	// User declarations
public:		// User declarations
  __fastcall TNewGalaxyModule(TComponent* Owner);
  void ActivateAllTables();
  void DeactivateAllTables();
  void SetDatabase(String aliasName);
  FilterDataSets(bool filtered);
  bool LoadDATFiles(String datPath);
  void CreateProject(String projectAlias);
};
//---------------------------------------------------------------------------
extern PACKAGE TNewGalaxyModule *NewGalaxyModule;
//---------------------------------------------------------------------------
#endif
