//---------------------------------------------------------------------------
#ifndef TStarMapViewH
#define TStarMapViewH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>

#include "TEFSCGalaxy.h"
#include <ActnList.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>

const int STAR_MAP_TILE_WIDTH = 16;
const int STAR_MAP_TILE_HEIGHT = 16;

//---------------------------------------------------------------------------
class TStarMapView : public TForm
{
__published:	// IDE-managed Components
  TPopupMenu *StarMapPopupMenu;
  TActionList *StarMapActions;
  TAction *ShowPlanetsAction;
  TAction *ShowPlanetNamesAction;
  TAction *ShowJumpGatesAction;
  TAction *ShowMapTileValuesAction;
  TMenuItem *ShowPlanets1;
  TMenuItem *ShowPlanetNames1;
  TMenuItem *ShowJumpRoutes1;
  TMenuItem *MapTileInfoMenu;
  TStatusBar *StatusBar;
  TScrollBox *SpaceScrollBox;
  TImage *Space;
  TAction *ShowUnitsAction;
  TMenuItem *ShowUnitsinSpace1;
  TMenuItem *ShowMapTileInfo2;
  TAction *SZMapTileValuesAction;
  TMenuItem *SupressInterstellarZeros1;
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall FormPaint(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall ShowPlanetsActionExecute(TObject *Sender);
  void __fastcall ShowPlanetNamesActionExecute(TObject *Sender);
  void __fastcall ShowJumpGatesActionExecute(TObject *Sender);
  void __fastcall ShowMapTileValuesActionExecute(TObject *Sender);
  void __fastcall SpaceMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  void __fastcall ShowUnitsActionExecute(TObject *Sender);
  void __fastcall SZMapTileValuesActionExecute(TObject *Sender);
private:	// User declarations
  TEFSCGalaxy* Galaxy;
  int TileWidth;
  int TileHeight;
  int SelTileX;
  int SelTileY;
  TColor CursorColor;
  TColor UnitSlotColor;
  void OutlineTile(int x, int y, TColor color, TPenMode penMode);
  //TLabel* TileCaptions[STAR_MAP_WIDTH][STAR_MAP_HEIGHT];

public:		// User declarations
  bool ShowPlanetNames;
  bool ShowPlanets;
  bool ShowJumpGates;
  bool ShowMapTileValues;
  bool ShowUnits;
  bool SupressZeros;

  __fastcall TStarMapView(TComponent* Owner);
  __fastcall TStarMapView(TComponent* Owner, TEFSCGalaxy* galaxy);
  void UpdateView();
protected:
  void MouseToTile(int x, int y, int& TileX, int& TileY);
};
//---------------------------------------------------------------------------
extern PACKAGE TStarMapView *StarMapView;
//---------------------------------------------------------------------------
#endif
